/*
  FDD Project
 

 */

// Definition des mins du lecteur de disquette
#include   <math.h>// requires an Atmega168 chip 


// note values for two octave scale
// divide them by powers of two to generate other octaves
float A     = 14080;
float AS    = 14917.2;
float B     = 15804.3;
float C     = 16744;
float CS    = 17739.7;
float D     = 18794.5;
float DS    = 19912.1;
float E     = 21096.2;
float F     = 22350.6;
float FS    = 23679.6;
float G     = 25087.7;
float GS    = 26579.5;
float A2P    = 28160;
float A2S   = 29834.5;
float B2    = 31608.5;
float C2    = 33488.1;
float C2S   = 35479.4;
float D2    = 37589.1;
float D2S   = 39824.3;
float E2    = 42192.3;
float F2    = 44701.2;
float F2S   = 47359.3;
float G2    = 50175.4;
float G2S   = 53159;
float A3P    = 56320;
float AS3   = 59669;
float B3    = 63217;
float C3    = 66976.2;

float REST  = 0;

int tempoFast = 50;
int tempoSlow =100;

  
// Moteur B : tête de lecture
const int FDD_motorB_on       = 2;     // motor on        output| FDD pin 16 
// Selection disque primaire
const int FDD_drive_select_A  = 3;     // drive select A   output| FDD pin 12 
// Selection disque secondaire
const int FDD_drive_select_B  = 4;     // drive select B   output| FDD pin 14 
// Sens de direction de la tête de lecture
const int FDD_direction       = 5;     // direction        output| FDD pin 18 
// pulsation de la tête de lecture (déplacement)
const int FDD_head_step       = 6;     // step pulse        output| FDD pin 20 
// Moteur A : rotation disque
const int FDD_motorA_on       = 7;     // motor on        output| FDD pin 10 
//selection de la densité
const int FDD_density_select  = 8;     // density select   output| FDD pin 2 
//selection de la tête
const int FDD_head_select  = 9;     // density select   output| FDD pin 32 
//selection de la tête
const int FDD_write_data  = 10;     // density select   output| FDD pin 22 
//retour d'information
const int FDD_track00        = 11;     // track00          input| FDD pin 26 début de la piste

//const int FDD_index          = 10;     // Index           input| FDD pin 8 

// variables will change:
int track00State = 0;         // variable for reading the pushbutton status


void setup() {
  
   Serial.begin(9600);
  // initialisation des pins du FDD en output
  pinMode(FDD_motorB_on, OUTPUT); 
  pinMode(FDD_motorA_on, OUTPUT);
  pinMode(FDD_drive_select_A, OUTPUT);
  pinMode(FDD_drive_select_B, OUTPUT); 
  pinMode(FDD_direction, OUTPUT); 
  pinMode(FDD_head_step, OUTPUT); 
  pinMode(FDD_density_select, OUTPUT);  
  pinMode(FDD_head_select, OUTPUT);  
  pinMode(FDD_write_data, OUTPUT); 
  pinMode(FDD_track00, INPUT);

  //initialisation
  digitalWrite(FDD_motorB_on, HIGH); 
  digitalWrite(FDD_motorA_on, HIGH);
  digitalWrite(FDD_drive_select_A, HIGH);
  digitalWrite(FDD_drive_select_B, HIGH); 
  digitalWrite(FDD_direction, HIGH); 
  digitalWrite(FDD_head_step, HIGH);
  digitalWrite(FDD_density_select, HIGH); 
  digitalWrite(FDD_head_select, HIGH); 
  digitalWrite(FDD_write_data, HIGH); 
  
  digitalWrite(FDD_track00, HIGH); //pulup resistance sur track00 en interne
       
}

void goTrack00()
{
   digitalWrite(FDD_motorB_on, LOW);
   digitalWrite(FDD_direction, HIGH); //retour vers la base
   track00State = digitalRead(FDD_track00);
  
  while ( track00State == HIGH ){
    
    digitalWrite(FDD_head_step, LOW);
    delay(1);
    digitalWrite(FDD_head_step, HIGH);
    delay(1);
    track00State = digitalRead(FDD_track00);
  }  
  digitalWrite(FDD_head_step, HIGH);
  digitalWrite(FDD_motorB_on, HIGH);
}






void playnote(int freq, int duree)
{
  
  int valeur=(1000/freq); //temps en ms pour osciller
  
  int newduree=duree/(valeur);
  
  //int newvaleur=(300000/freq)/2; //old avec premier exemple
   int newvaleur=(300000/freq)/2; 
  
  for (int i=0; i<newduree; i++){
    
    digitalWrite(FDD_direction, LOW);
    digitalWrite(FDD_head_step, LOW);
    delayMicroseconds(newvaleur);
    digitalWrite(FDD_head_step, HIGH);
    delayMicroseconds(newvaleur);
    
    digitalWrite(FDD_direction, HIGH);
    digitalWrite(FDD_head_step, LOW);
    delayMicroseconds(newvaleur);
    digitalWrite(FDD_head_step, HIGH);
    delayMicroseconds(newvaleur);
    
  
  }
 
}

float EIGHTH = 1;
float DOTTED_EIGHTH = 1.5;
float QUARTER = 2;
float DOTTED_QUARTER =3;
float HALF = 4;
float WHOLE = 8;
float ETERNITY =-1;


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// My Mario Music
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

int cNumSongs = 7;

float song0[] = 
  {
    E2,EIGHTH, E2,QUARTER, E2,EIGHTH, REST,EIGHTH, C2,EIGHTH, E2,QUARTER, G2,HALF, G,HALF, 
    REST,ETERNITY
  };
float song1[] = 
  {
    C2,DOTTED_QUARTER, G,EIGHTH, REST,QUARTER, E,QUARTER, REST,EIGHTH, A2P,QUARTER, B2,EIGHTH, REST,EIGHTH, A2S,EIGHTH, A2P,QUARTER,
    G,DOTTED_EIGHTH, E2,DOTTED_EIGHTH, G2,EIGHTH, A3P,QUARTER, F2,EIGHTH, G2,EIGHTH, REST,EIGHTH, E2,QUARTER, C2,EIGHTH, D2,EIGHTH, B2,DOTTED_QUARTER,
    REST,ETERNITY  
  };
float song2[] = 
  {
    C2,DOTTED_QUARTER, G,EIGHTH, REST,QUARTER, E,QUARTER, REST,EIGHTH, A2P,QUARTER, B2,EIGHTH, REST,EIGHTH, A2S,EIGHTH, A2P,QUARTER,
    G,DOTTED_EIGHTH, E2,DOTTED_EIGHTH, G2,EIGHTH, A3P,QUARTER, F2,EIGHTH, G2,EIGHTH, REST,EIGHTH, E2,QUARTER, C2,EIGHTH, D2,EIGHTH, B2,DOTTED_QUARTER,
    REST,ETERNITY  
  };
float song3[] = 
  {
    REST,QUARTER, G2,EIGHTH, F2S,EIGHTH, F2,EIGHTH, D2S,QUARTER, E2,EIGHTH, REST,EIGHTH, GS,EIGHTH, A2P,EIGHTH, C2,EIGHTH, REST,EIGHTH, A2P,EIGHTH, C2,EIGHTH, D2,EIGHTH,
    REST,QUARTER, G2,EIGHTH, F2S,EIGHTH, F2,EIGHTH, D2S,QUARTER, E2,EIGHTH, REST,EIGHTH, C3,QUARTER, C3,EIGHTH, C3,HALF,
    REST,ETERNITY  
  };
float song4[] = 
  {
    REST,QUARTER, G2,EIGHTH, F2S,EIGHTH, F2,EIGHTH, D2S,QUARTER, E2,EIGHTH, REST,EIGHTH, GS,EIGHTH, A2P,EIGHTH, C2,EIGHTH, REST,EIGHTH, A2P,EIGHTH, C2,EIGHTH, D2,EIGHTH,
    REST,QUARTER, D2S,QUARTER, REST,EIGHTH, D2,DOTTED_QUARTER, C2,HALF, REST,HALF,
    REST,ETERNITY  
  };
float song5[] = 
  {
    C2,EIGHTH, C2,QUARTER, C2,EIGHTH, REST,EIGHTH, C2,EIGHTH, D2,QUARTER, E2,EIGHTH, C2,QUARTER, A2P,EIGHTH, G,HALF,
    C2,EIGHTH, C2,QUARTER, C2,EIGHTH, REST,EIGHTH, C2,EIGHTH, D2,EIGHTH, E2,EIGHTH, REST,WHOLE,
    REST,ETERNITY  
  };
float song6[] = 
{
    C2,EIGHTH, C2,QUARTER, C2,EIGHTH, REST,EIGHTH, C2,EIGHTH, D2,QUARTER, E2,EIGHTH, C2,QUARTER, A2P,EIGHTH, G,HALF,
    E2,EIGHTH, E2,QUARTER, E2,EIGHTH, REST,EIGHTH, C2,EIGHTH, E2,QUARTER, G2,QUARTER, REST, HALF,
    REST,ETERNITY  
};

float* songs[] = 
{
  song0,
  song1,
  song2,
  song3,
  song4,
  song5,
  song6,
};

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// PlaySong()
//
// Just a little function to play  music and light LED's
//
void PlaySong(int songIndex, int tempo)
{
  
  if (songIndex < 0 || songIndex >= cNumSongs)
  {
    return;
  }
  
//  Serial.println("PlaySong");
  
  float* song = songs[songIndex];
  
  int x;
  for(x= 0; x<10000; x=x+2)
  {
    int noteval = (int)(song[x] / 256.0f);
    int dur = (int)((float)tempo * song[x+1]);
    
    if(dur < 0)
      break;
    
    playnote(noteval, dur*2);   
    

    delay(10);
  }
}









void loop(){
  
  //goTrack00();
  digitalWrite(FDD_motorB_on, LOW);
  
//  for (int j=0; j<100; j++){
//    Serial.print("play note ");
//    Serial.print(j,DEC);
//    Serial.println();
//    playnote(j, 300);
//  }

  
  
//  for (int thisNote = 0; thisNote < 8; thisNote++) {
//  
//      // to calculate the note duration, take one second 
//      // divided by the note type.
//      //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
//      int noteDuration = 1000/noteDurations[thisNote];
//      playnote(melody[thisNote],noteDuration);
//  
//      // to distinguish the notes, set a minimum time between them.
//      // the note's duration + 30% seems to work well:
//      int pauseBetweenNotes = noteDuration * 1.30;
//      delay(pauseBetweenNotes);
//      // stop the tone playing:
//      
//    }  


      PlaySong(1, 100);
      PlaySong(2, 100);
      PlaySong(3, 100);
      PlaySong(4, 100);
      PlaySong(5, 100);
      PlaySong(6, 100);
  
  digitalWrite(FDD_motorB_on, HIGH);
//  //mise en marche du moteur
//  digitalWrite(FDD_motorB_on, LOW);  
//  digitalWrite(FDD_motorA_on, LOW);  
//  digitalWrite(FDD_head_select, LOW);
//  //selection du disque A
//  
// test(1);
// test(2);
// test(3);
// test(4);
// test(5);
// test(6);
// test(7);
// test(8);
// test(9);
  while(1){
//   digitalWrite(FDD_motorB_on, LOW);
//    playnote(440,1000);
//  digitalWrite(FDD_motorB_on, HIGH);
  }
  
}
